package cokr.xit.fims.levy.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;
import cokr.xit.fims.levy.Levy;
import cokr.xit.fims.levy.LevyQuery;

/** 부과 대장 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-30	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("levyMapper")
public interface LevyMapper extends AbstractMapper {

	/**지정한 조건에 따라 부과 대장 목록을 조회하여 반환한다.<br />
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 목록
	 */
	List<DataObject> selectLevyList(LevyQuery req);

	/**지정한 조건에 따라 부과 대장 객체들을 반환한다.
	 * @param req 부과 대장 조회 조건
	 * @return 부과 대장 객체 목록
	 */
	List<DataObject> selectLevys(LevyQuery req);

	/**지정한 부과 ID에 따라 부과 대장 객체를 반환한다.
	 * @param levyId 부과 ID
	 * @return 부과 대장 객체
	 */
	default DataObject selectLevyInfo(LevyQuery req) {
		List<DataObject> levys = selectLevys(req);

		return !levys.isEmpty() ? levys.get(0) : null;
	}

	/**부과 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"levy" - 부과 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertLevy(Map<String, Object> params);

	/**부과 대장 정보를 등록한다.
	 * @param levy 부과 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(Levy levy) {
		return levy != null && insertLevy(params().set("levy", levy)) == 1;
	}

	/**부과 대장 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"levy" - 부과 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateLevy(Map<String, Object> params);

	/**부과 대장 정보를 수정한다.
	 * @param levy 부과 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(Levy levy) {
		return levy != null && updateLevy(params().set("levy", levy)) == 1;
	}

	/**지정한 부과 대장을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"levy" - 부과 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteLevy(Map<String, ?> params);

	/**부과 대장 정보를 삭제한다.
	 * @param levy 부과 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(Levy levy) {
		return levy != null && deleteLevy(params().set("levy", levy)) == 1;
	}

}
